#include "order.hpp"

Order::Order(int nr, int cardNr) : _number(nr), _cardNumber(cardNr)
{
}

Order::Order(const Order& other)
{
    _number = other._number;
    _cardNumber = other._cardNumber;

    for (int i = 0; i < other._items.size(); i++)
    // t kell msolnunk a listt, az elemek jra ltrehozsval
    {
        switch (other._items[i]->getType()) // tpustl fgg, mit vesznk fel
        {
        case 'k':
            _items.push_back(new Coke());
            break;
        case 'n':
            _items.push_back(new Orange());
            break;
        case 't':
            _items.push_back(new Tea());
            break;
        case 'h':
            _items.push_back(new Hamburger(other._items[i]->getName(), other._items[i]->getTotalValue()));
            // tel esetn lekrdezzk az rat s nevet
            break;
        case 'u':
            _items.push_back(new Ufo(other._items[i]->getName(), other._items[i]->getTotalValue()));
            break;
        case 'p':
            _items.push_back(new Pancake(other._items[i]->getName(), other._items[i]->getTotalValue()));
            break;
        }
    }
}

Order::~Order()
{
    for (int i = 0; i < _items.size(); i++)
        delete _items[i]; // elemek trlse
    _items.clear();
}

Order& Order::operator=(const Order& other)
{
    if (this == &other)
        return *this;

    for (int i = 0; i < _items.size(); i++) // rgi elemek trlse
        delete _items[i];
    _items.clear();

    _number = other._number;
    _cardNumber = other._cardNumber;

    for (int i = 0; i < other._items.size(); i++)
    // t kell msolnunk a listt, az elemek jra ltrehozsval
    {
        switch (other._items[i]->getType()) // tpustl fgg, mit vesznk fel
        {
        case 'k':
            _items.push_back(new Coke());
            break;
        case 'n':
            _items.push_back(new Orange());
            break;
        case 't':
            _items.push_back(new Tea());
            break;
        case 'h':
            _items.push_back(new Hamburger(other._items[i]->getName(), other._items[i]->getTotalValue()));
            // tel esetn lekrdezzk az rat s nevet
            break;
        case 'u':
            _items.push_back(new Ufo(other._items[i]->getName(), other._items[i]->getTotalValue()));
            break;
        case 'p':
            _items.push_back(new Pancake(other._items[i]->getName(), other._items[i]->getTotalValue()));
            break;
        }
    }

    return *this;
}

void Order::addItem(char type)
{
    // ellenrizzk a tpust
    if (type != 'k' && type != 'n' && type != 't')
        throw UNSUPPORTED_ITEM_TYPE;

    switch (type) // felvesszk a megfelel ttelt
    {
    case 'k':
        _items.push_back(new Coke());
        break;
    case 'n':
        _items.push_back(new Orange());
        break;
    case 't':
        _items.push_back(new Tea());
        break;
    }
}

void Order::addItem(char type, std::string name, int cost)
{
    if (type != 'h' && type != 'u' && type != 'p')
        throw UNSUPPORTED_ITEM_TYPE;

    switch (type)
    {
    case 'h':
        _items.push_back(new Hamburger(name, cost));
        break;
    case 'u':
        _items.push_back(new Ufo(name, cost));
        break;
    case 'p':
        _items.push_back(new Pancake(name, cost));
        break;
    }
}

int Order::getNumber() const
{
    return _number;
}

int Order::getCardNumber() const
{
    return _cardNumber;
}

Item* Order::getItem(int index) const
{
    if (index < 0 || index >= _items.size())
        throw INDEX_OUT_OF_RANGE;

    return _items[index];
}

int Order::getItemCount() const
{
    return _items.size();
}

int Order::getNetValue() const
{
    // a lekrdezshez sszegezzk a lista elemeinek nett rtkt
    int value = 0;
    for (int i = 0; i < _items.size(); i++)
        value += _items[i]->getNetValue();
    return value;
}
int Order::getTotalValue() const
{
    int value = 0;
    for (int i = 0; i < _items.size(); i++)
        value += _items[i]->getTotalValue();
    return value;
}
