#ifndef ORDER_HPP
#define ORDER_HPP

#include "vector.hpp"
#include "item.hpp"

class Order // rendels
{
public:
    Order(int nr = 0, int cardNr = 0); // rendels ltrehozsa azonost s krtyaszm alapjn
    Order(const Order& other);
    ~Order();
    Order& operator=(const Order& other);
    void addItem(char type); // ttel felvtele tpus alapjn
    void addItem(char type, std::string name, int cost); // ttel felvtele tpus, nv s r alapjn
    int getNumber() const; // sorszm lekrdezse
    int getCardNumber() const; // trzsvsrli szm lekrdezse
    Item* getItem(int index) const; // ttel lekrdezse
    int getItemCount() const; // ttelek szmnak lekrdezse
    int getNetValue() const; // rendels nett rtke
    int getTotalValue() const; // rendels brutt rtke

    enum Exceptions { UNSUPPORTED_ITEM_TYPE, INDEX_OUT_OF_RANGE };
private:
    int _number; // sorszm
    int _cardNumber; // trzsvsrli szm
    vector<Item*> _items; // ttelek listja
};

#endif // ORDER_HPP
